﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace RealCustomWpfControl
{

    [TemplatePart(Name="PART_Target", Type=typeof(Shape))]
    public class TargetControl : Control
    {
        static TargetControl()
        {
            DefaultStyleKeyProperty.OverrideMetadata(
                typeof(TargetControl),
                new FrameworkPropertyMetadata(typeof(TargetControl)));
        }

        Shape targetElement;

        public override void OnApplyTemplate()
        {
            Shape newTarget = null;
            if (this.Template != null)
            {
                newTarget = this.Template.FindName("PART_Target", this)
                    as Shape;

            }

            if (newTarget != targetElement)
            {
                if (targetElement != null)
                {
                    targetElement.MouseDown -= new MouseButtonEventHandler(targetElement_MouseDown);
                }

                targetElement = newTarget;
                if (targetElement != null)
                {
                    targetElement.MouseDown += new MouseButtonEventHandler(targetElement_MouseDown);
                }
            }
        }

        void targetElement_MouseDown(object sender, MouseButtonEventArgs e)
        {
            targetElement.Fill = Brushes.Yellow;
        }
    }
}
