﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.ComponentModel;
using System.Threading;
using System.Diagnostics;

namespace CrossThreadDataBinding
{
    public class SlowSource : INotifyPropertyChanged
    {
        private string dataValue = "";
        public string Data
        {
            get
            {
                Debug.WriteLine("Get Thread: " + Thread.CurrentThread.ManagedThreadId);
                return dataValue;
            }
            set
            {
                Debug.WriteLine("Set Thread: " + Thread.CurrentThread.ManagedThreadId);
                if (value != dataValue)
                {
                    dataValue = value;
                    OnPropertyChanged("Data");
                }
            }
        }

        public void FetchNewData()
        {
            ThreadPool.QueueUserWorkItem(delegate
            {
                Thread.Sleep(5000);
                Debug.WriteLine("Worker Thread: " + Thread.CurrentThread.ManagedThreadId);

                this.Data += "!!";
            });
        }


        #region INotifyPropertyChanged Members

        public event PropertyChangedEventHandler PropertyChanged = delegate {};

        private void OnPropertyChanged(string propertyName)
        {
            Debug.WriteLine("Event Thread: " + Thread.CurrentThread.ManagedThreadId);
            PropertyChanged(this, new PropertyChangedEventArgs(propertyName));
        }

        #endregion
    }
}
